pragma Ada_2012;

pragma Style_Checks (Off);
pragma Warnings (Off, "-gnatwu");

with Interfaces.C; use Interfaces.C;
with Interfaces.C.Strings;
with Interfaces.C.Extensions;
with System;
with dbus_types_h;

package dbus_errors_h is

   --  unsupported macro: DBUS_ERROR_INIT { NULL, NULL, TRUE, 0, 0, 0, 0, NULL }
   type DBusError;
   type DBusError is record
      name : Interfaces.C.Strings.chars_ptr;  -- dbus-errors.h:52
      message : Interfaces.C.Strings.chars_ptr;  -- dbus-errors.h:53
      dummy1 : Extensions.Unsigned_1;  -- dbus-errors.h:55
      dummy2 : Extensions.Unsigned_1;  -- dbus-errors.h:56
      dummy3 : Extensions.Unsigned_1;  -- dbus-errors.h:57
      dummy4 : Extensions.Unsigned_1;  -- dbus-errors.h:58
      dummy5 : Extensions.Unsigned_1;  -- dbus-errors.h:59
      padding1 : System.Address;  -- dbus-errors.h:61
   end record
   with Convention => C_Pass_By_Copy,
        Pack => True,
        Alignment => 8;  -- dbus-errors.h:50

   procedure dbus_error_init (error : access DBusError)  -- dbus-errors.h:67
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_error_init";

   procedure dbus_error_free (error : access DBusError)  -- dbus-errors.h:69
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_error_free";

   procedure dbus_set_error
     (error : access DBusError;
      name : Interfaces.C.Strings.chars_ptr;
      message : Interfaces.C.Strings.chars_ptr  -- , ...
      )  -- dbus-errors.h:71
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_set_error";

   procedure dbus_set_error_const
     (error : access DBusError;
      name : Interfaces.C.Strings.chars_ptr;
      message : Interfaces.C.Strings.chars_ptr)  -- dbus-errors.h:76
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_set_error_const";

   procedure dbus_move_error (src : access DBusError; dest : access DBusError)  -- dbus-errors.h:80
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_move_error";

   function dbus_error_has_name (error : access constant DBusError; name : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-errors.h:83
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_error_has_name";

   function dbus_error_is_set (error : access constant DBusError) return dbus_types_h.dbus_bool_t  -- dbus-errors.h:86
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_error_is_set";

end dbus_errors_h;

pragma Style_Checks (On);
pragma Warnings (On, "-gnatwu");
