pragma Ada_2012;

pragma Style_Checks (Off);
pragma Warnings (Off, "-gnatwu");

with Interfaces.C; use Interfaces.C;
with System;
with dbus_arch_deps_h;
with Interfaces.C.Strings;
with dbus_types_h;
limited with dbus_errors_h;
with dbus_memory_h;

package dbus_message_h is

   --  unsupported macro: DBUS_MESSAGE_ITER_INIT_CLOSED { NULL, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL }
   type DBusMessage is null record;   -- incomplete struct

   type DBusMessageIter;
   type DBusMessageIter is record
      dummy1 : System.Address;  -- dbus-message.h:68
      dummy2 : System.Address;  -- dbus-message.h:69
      dummy3 : aliased dbus_arch_deps_h.dbus_uint32_t;  -- dbus-message.h:70
      dummy4 : aliased int;  -- dbus-message.h:71
      dummy5 : aliased int;  -- dbus-message.h:72
      dummy6 : aliased int;  -- dbus-message.h:73
      dummy7 : aliased int;  -- dbus-message.h:74
      dummy8 : aliased int;  -- dbus-message.h:75
      dummy9 : aliased int;  -- dbus-message.h:76
      dummy10 : aliased int;  -- dbus-message.h:77
      dummy11 : aliased int;  -- dbus-message.h:78
      pad1 : aliased int;  -- dbus-message.h:79
      pad2 : System.Address;  -- dbus-message.h:80
      pad3 : System.Address;  -- dbus-message.h:81
   end record
   with Convention => C_Pass_By_Copy;  -- dbus-message.h:63

   function dbus_message_new (message_type : int) return access DBusMessage  -- dbus-message.h:120
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_new";

   function dbus_message_new_method_call
     (bus_name : Interfaces.C.Strings.chars_ptr;
      path : Interfaces.C.Strings.chars_ptr;
      iface : Interfaces.C.Strings.chars_ptr;
      method : Interfaces.C.Strings.chars_ptr) return access DBusMessage  -- dbus-message.h:122
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_new_method_call";

   function dbus_message_new_method_return (method_call : access DBusMessage) return access DBusMessage  -- dbus-message.h:127
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_new_method_return";

   function dbus_message_new_signal
     (path : Interfaces.C.Strings.chars_ptr;
      iface : Interfaces.C.Strings.chars_ptr;
      name : Interfaces.C.Strings.chars_ptr) return access DBusMessage  -- dbus-message.h:129
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_new_signal";

   function dbus_message_new_error
     (reply_to : access DBusMessage;
      error_name : Interfaces.C.Strings.chars_ptr;
      error_message : Interfaces.C.Strings.chars_ptr) return access DBusMessage  -- dbus-message.h:133
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_new_error";

   function dbus_message_new_error_printf
     (reply_to : access DBusMessage;
      error_name : Interfaces.C.Strings.chars_ptr;
      error_format : Interfaces.C.Strings.chars_ptr  -- , ...
      ) return access DBusMessage  -- dbus-message.h:137
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_new_error_printf";

   function dbus_message_copy (message : access constant DBusMessage) return access DBusMessage  -- dbus-message.h:143
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_copy";

   function dbus_message_ref (message : access DBusMessage) return access DBusMessage  -- dbus-message.h:146
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_ref";

   procedure dbus_message_unref (message : access DBusMessage)  -- dbus-message.h:148
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_unref";

   function dbus_message_get_type (message : access DBusMessage) return int  -- dbus-message.h:150
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_type";

   function dbus_message_set_path (message : access DBusMessage; object_path : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:152
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_path";

   function dbus_message_get_path (message : access DBusMessage) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:155
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_path";

   function dbus_message_has_path (message : access DBusMessage; object_path : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:157
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_has_path";

   function dbus_message_set_interface (message : access DBusMessage; iface : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:160
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_interface";

   function dbus_message_get_interface (message : access DBusMessage) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:163
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_interface";

   function dbus_message_has_interface (message : access DBusMessage; iface : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:165
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_has_interface";

   function dbus_message_set_member (message : access DBusMessage; member : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:168
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_member";

   function dbus_message_get_member (message : access DBusMessage) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:171
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_member";

   function dbus_message_has_member (message : access DBusMessage; member : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:173
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_has_member";

   function dbus_message_set_error_name (message : access DBusMessage; name : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:176
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_error_name";

   function dbus_message_get_error_name (message : access DBusMessage) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:179
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_error_name";

   function dbus_message_set_destination (message : access DBusMessage; destination : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:181
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_destination";

   function dbus_message_get_destination (message : access DBusMessage) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:184
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_destination";

   function dbus_message_set_sender (message : access DBusMessage; sender : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:186
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_sender";

   function dbus_message_get_sender (message : access DBusMessage) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:189
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_sender";

   function dbus_message_get_signature (message : access DBusMessage) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:191
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_signature";

   procedure dbus_message_set_no_reply (message : access DBusMessage; no_reply : dbus_types_h.dbus_bool_t)  -- dbus-message.h:193
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_no_reply";

   function dbus_message_get_no_reply (message : access DBusMessage) return dbus_types_h.dbus_bool_t  -- dbus-message.h:196
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_no_reply";

   function dbus_message_is_method_call
     (message : access DBusMessage;
      iface : Interfaces.C.Strings.chars_ptr;
      method : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:198
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_is_method_call";

   function dbus_message_is_signal
     (message : access DBusMessage;
      iface : Interfaces.C.Strings.chars_ptr;
      signal_name : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:202
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_is_signal";

   function dbus_message_is_error (message : access DBusMessage; error_name : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:206
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_is_error";

   function dbus_message_has_destination (message : access DBusMessage; bus_name : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:209
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_has_destination";

   function dbus_message_has_sender (message : access DBusMessage; unique_bus_name : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:212
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_has_sender";

   function dbus_message_has_signature (message : access DBusMessage; signature : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:215
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_has_signature";

   function dbus_message_get_serial (message : access DBusMessage) return dbus_arch_deps_h.dbus_uint32_t  -- dbus-message.h:218
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_serial";

   procedure dbus_message_set_serial (message : access DBusMessage; serial : dbus_arch_deps_h.dbus_uint32_t)  -- dbus-message.h:220
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_serial";

   function dbus_message_set_reply_serial (message : access DBusMessage; reply_serial : dbus_arch_deps_h.dbus_uint32_t) return dbus_types_h.dbus_bool_t  -- dbus-message.h:223
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_reply_serial";

   function dbus_message_get_reply_serial (message : access DBusMessage) return dbus_arch_deps_h.dbus_uint32_t  -- dbus-message.h:226
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_reply_serial";

   procedure dbus_message_set_auto_start (message : access DBusMessage; auto_start : dbus_types_h.dbus_bool_t)  -- dbus-message.h:229
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_auto_start";

   function dbus_message_get_auto_start (message : access DBusMessage) return dbus_types_h.dbus_bool_t  -- dbus-message.h:232
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_auto_start";

   function dbus_message_get_path_decomposed (message : access DBusMessage; path : System.Address) return dbus_types_h.dbus_bool_t  -- dbus-message.h:235
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_path_decomposed";

   function dbus_message_get_container_instance (message : access DBusMessage) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:239
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_container_instance";

   function dbus_message_set_container_instance (message : access DBusMessage; object_path : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-message.h:241
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_container_instance";

   function dbus_message_append_args (message : access DBusMessage; first_arg_type : int  -- , ...
      ) return dbus_types_h.dbus_bool_t  -- dbus-message.h:245
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_append_args";

   function dbus_message_get_args
     (message : access DBusMessage;
      error : access dbus_errors_h.DBusError;
      first_arg_type : int  -- , ...
      ) return dbus_types_h.dbus_bool_t  -- dbus-message.h:253
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_args";

   function dbus_message_contains_unix_fds (message : access DBusMessage) return dbus_types_h.dbus_bool_t  -- dbus-message.h:264
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_contains_unix_fds";

   procedure dbus_message_iter_init_closed (iter : access DBusMessageIter)  -- dbus-message.h:267
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_init_closed";

   function dbus_message_iter_init (message : access DBusMessage; iter : access DBusMessageIter) return dbus_types_h.dbus_bool_t  -- dbus-message.h:269
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_init";

   function dbus_message_iter_has_next (iter : access DBusMessageIter) return dbus_types_h.dbus_bool_t  -- dbus-message.h:272
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_has_next";

   function dbus_message_iter_next (iter : access DBusMessageIter) return dbus_types_h.dbus_bool_t  -- dbus-message.h:274
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_next";

   function dbus_message_iter_get_signature (iter : access DBusMessageIter) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:276
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_get_signature";

   function dbus_message_iter_get_arg_type (iter : access DBusMessageIter) return int  -- dbus-message.h:278
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_get_arg_type";

   function dbus_message_iter_get_element_type (iter : access DBusMessageIter) return int  -- dbus-message.h:280
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_get_element_type";

   procedure dbus_message_iter_recurse (iter : access DBusMessageIter; sub : access DBusMessageIter)  -- dbus-message.h:282
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_recurse";

   procedure dbus_message_iter_get_basic (iter : access DBusMessageIter; value : System.Address)  -- dbus-message.h:285
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_get_basic";

   function dbus_message_iter_get_element_count (iter : access DBusMessageIter) return int  -- dbus-message.h:288
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_get_element_count";

   function dbus_message_iter_get_array_len (iter : access DBusMessageIter) return int  -- dbus-message.h:295
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_get_array_len";

   procedure dbus_message_iter_get_fixed_array
     (iter : access DBusMessageIter;
      value : System.Address;
      n_elements : access int)  -- dbus-message.h:298
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_get_fixed_array";

   procedure dbus_message_iter_init_append (message : access DBusMessage; iter : access DBusMessageIter)  -- dbus-message.h:304
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_init_append";

   function dbus_message_iter_append_basic
     (iter : access DBusMessageIter;
      c_type : int;
      value : System.Address) return dbus_types_h.dbus_bool_t  -- dbus-message.h:307
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_append_basic";

   function dbus_message_iter_append_fixed_array
     (iter : access DBusMessageIter;
      element_type : int;
      value : System.Address;
      n_elements : int) return dbus_types_h.dbus_bool_t  -- dbus-message.h:311
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_append_fixed_array";

   function dbus_message_iter_open_container
     (iter : access DBusMessageIter;
      c_type : int;
      contained_signature : Interfaces.C.Strings.chars_ptr;
      sub : access DBusMessageIter) return dbus_types_h.dbus_bool_t  -- dbus-message.h:316
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_open_container";

   function dbus_message_iter_close_container (iter : access DBusMessageIter; sub : access DBusMessageIter) return dbus_types_h.dbus_bool_t  -- dbus-message.h:321
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_close_container";

   procedure dbus_message_iter_abandon_container (iter : access DBusMessageIter; sub : access DBusMessageIter)  -- dbus-message.h:324
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_abandon_container";

   procedure dbus_message_iter_abandon_container_if_open (iter : access DBusMessageIter; sub : access DBusMessageIter)  -- dbus-message.h:328
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_iter_abandon_container_if_open";

   procedure dbus_message_lock (message : access DBusMessage)  -- dbus-message.h:332
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_lock";

   function dbus_set_error_from_message (error : access dbus_errors_h.DBusError; message : access DBusMessage) return dbus_types_h.dbus_bool_t  -- dbus-message.h:335
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_set_error_from_message";

   function dbus_message_allocate_data_slot (slot_p : access dbus_arch_deps_h.dbus_int32_t) return dbus_types_h.dbus_bool_t  -- dbus-message.h:340
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_allocate_data_slot";

   procedure dbus_message_free_data_slot (slot_p : access dbus_arch_deps_h.dbus_int32_t)  -- dbus-message.h:342
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_free_data_slot";

   function dbus_message_set_data
     (message : access DBusMessage;
      slot : dbus_arch_deps_h.dbus_int32_t;
      data : System.Address;
      free_data_func : dbus_memory_h.DBusFreeFunction) return dbus_types_h.dbus_bool_t  -- dbus-message.h:344
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_data";

   function dbus_message_get_data (message : access DBusMessage; slot : dbus_arch_deps_h.dbus_int32_t) return System.Address  -- dbus-message.h:349
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_data";

   function dbus_message_type_from_string (type_str : Interfaces.C.Strings.chars_ptr) return int  -- dbus-message.h:353
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_type_from_string";

   function dbus_message_type_to_string (c_type : int) return Interfaces.C.Strings.chars_ptr  -- dbus-message.h:355
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_type_to_string";

   function dbus_message_marshal
     (msg : access DBusMessage;
      marshalled_data_p : System.Address;
      len_p : access int) return dbus_types_h.dbus_bool_t  -- dbus-message.h:358
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_marshal";

   function dbus_message_demarshal
     (str : Interfaces.C.Strings.chars_ptr;
      len : int;
      error : access dbus_errors_h.DBusError) return access DBusMessage  -- dbus-message.h:362
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_demarshal";

   function dbus_message_demarshal_bytes_needed (str : Interfaces.C.Strings.chars_ptr; len : int) return int  -- dbus-message.h:367
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_demarshal_bytes_needed";

   procedure dbus_message_set_allow_interactive_authorization (message : access DBusMessage; allow : dbus_types_h.dbus_bool_t)  -- dbus-message.h:371
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_set_allow_interactive_authorization";

   function dbus_message_get_allow_interactive_authorization (message : access DBusMessage) return dbus_types_h.dbus_bool_t  -- dbus-message.h:375
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_message_get_allow_interactive_authorization";

   procedure dbus_clear_message (pointer_to_message : System.Address)  -- dbus-message.h:391
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_clear_message";

end dbus_message_h;

pragma Style_Checks (On);
pragma Warnings (On, "-gnatwu");
