pragma Ada_2012;

pragma Style_Checks (Off);
pragma Warnings (Off, "-gnatwu");

with Interfaces.C; use Interfaces.C;
with Interfaces.C.Strings;
with dbus_types_h;
limited with dbus_errors_h;

package dbus_misc_h is

   function dbus_get_local_machine_id return Interfaces.C.Strings.chars_ptr  -- dbus-misc.h:42
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_get_local_machine_id";

   procedure dbus_get_version
     (major_version_p : access int;
      minor_version_p : access int;
      micro_version_p : access int)  -- dbus-misc.h:45
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_get_version";

   function dbus_setenv (variable : Interfaces.C.Strings.chars_ptr; value : Interfaces.C.Strings.chars_ptr) return dbus_types_h.dbus_bool_t  -- dbus-misc.h:50
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_setenv";

   function dbus_try_get_local_machine_id (error : access dbus_errors_h.DBusError) return Interfaces.C.Strings.chars_ptr  -- dbus-misc.h:54
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_try_get_local_machine_id";

end dbus_misc_h;

pragma Style_Checks (On);
pragma Warnings (On, "-gnatwu");
