pragma Ada_2012;

pragma Style_Checks (Off);
pragma Warnings (Off, "-gnatwu");


package dbus_shared_h is

   DBUS_SERVICE_DBUS : aliased constant String := "org.freedesktop.DBus" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:78

   DBUS_PATH_DBUS : aliased constant String := "/org/freedesktop/DBus" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:82

   DBUS_PATH_LOCAL : aliased constant String := "/org/freedesktop/DBus/Local" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:84

   DBUS_INTERFACE_DBUS : aliased constant String := "org.freedesktop.DBus" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:90

   DBUS_INTERFACE_MONITORING : aliased constant String := "org.freedesktop.DBus.Monitoring" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:92

   DBUS_INTERFACE_VERBOSE : aliased constant String := "org.freedesktop.DBus.Verbose" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:95

   DBUS_INTERFACE_INTROSPECTABLE : aliased constant String := "org.freedesktop.DBus.Introspectable" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:97

   DBUS_INTERFACE_PROPERTIES : aliased constant String := "org.freedesktop.DBus.Properties" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:99

   DBUS_INTERFACE_PEER : aliased constant String := "org.freedesktop.DBus.Peer" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:101

   DBUS_INTERFACE_LOCAL : aliased constant String := "org.freedesktop.DBus.Local" & ASCII.NUL;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:107

   DBUS_NAME_FLAG_ALLOW_REPLACEMENT : constant := 16#1#;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:110
   DBUS_NAME_FLAG_REPLACE_EXISTING : constant := 16#2#;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:111
   DBUS_NAME_FLAG_DO_NOT_QUEUE : constant := 16#4#;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:112

   DBUS_REQUEST_NAME_REPLY_IN_QUEUE : constant := 2;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:116
   DBUS_REQUEST_NAME_REPLY_EXISTS : constant := 3;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:117

   DBUS_RELEASE_NAME_REPLY_RELEASED : constant := 1;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:121

   DBUS_START_REPLY_SUCCESS : constant := 1;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:126
   DBUS_START_REPLY_ALREADY_RUNNING : constant := 2;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:127

   DBUS_REQUEST_NAME_REPLY_PRIMARY_OWNER : constant := 1;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:115

   DBUS_REQUEST_NAME_REPLY_ALREADY_OWNER : constant := 4;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:118

   DBUS_RELEASE_NAME_REPLY_NON_EXISTENT : constant := 2;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:122
   DBUS_RELEASE_NAME_REPLY_NOT_OWNER : constant := 3;  --  /usr/include/dbus-1.0/dbus/dbus-shared.h:123

   type DBusBusType is 
     (DBUS_BUS_SESSION,
      DBUS_BUS_SYSTEM,
      DBUS_BUS_STARTER)
   with Convention => C;  -- dbus-shared.h:63

   type DBusHandlerResult is 
     (DBUS_HANDLER_RESULT_HANDLED,
      DBUS_HANDLER_RESULT_NOT_YET_HANDLED,
      DBUS_HANDLER_RESULT_NEED_MEMORY)
   with Convention => C;  -- dbus-shared.h:73

end dbus_shared_h;

pragma Style_Checks (On);
pragma Warnings (On, "-gnatwu");
