pragma Ada_2012;

pragma Style_Checks (Off);
pragma Warnings (Off, "-gnatwu");

with Interfaces.C; use Interfaces.C;
with System;
with dbus_arch_deps_h;
with Interfaces.C.Strings;
with dbus_types_h;
limited with dbus_errors_h;

package dbus_signature_h is

   type DBusSignatureIter is record
      dummy1 : System.Address;  -- dbus-signature.h:48
      dummy2 : System.Address;  -- dbus-signature.h:49
      dummy8 : aliased dbus_arch_deps_h.dbus_uint32_t;  -- dbus-signature.h:50
      dummy12 : aliased int;  -- dbus-signature.h:51
      dummy17 : aliased int;  -- dbus-signature.h:52
   end record
   with Convention => C_Pass_By_Copy;  -- dbus-signature.h:53

   procedure dbus_signature_iter_init (iter : access DBusSignatureIter; signature : Interfaces.C.Strings.chars_ptr)  -- dbus-signature.h:56
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_signature_iter_init";

   function dbus_signature_iter_get_current_type (iter : access constant DBusSignatureIter) return int  -- dbus-signature.h:60
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_signature_iter_get_current_type";

   function dbus_signature_iter_get_signature (iter : access constant DBusSignatureIter) return Interfaces.C.Strings.chars_ptr  -- dbus-signature.h:63
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_signature_iter_get_signature";

   function dbus_signature_iter_get_element_type (iter : access constant DBusSignatureIter) return int  -- dbus-signature.h:66
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_signature_iter_get_element_type";

   function dbus_signature_iter_next (iter : access DBusSignatureIter) return dbus_types_h.dbus_bool_t  -- dbus-signature.h:69
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_signature_iter_next";

   procedure dbus_signature_iter_recurse (iter : access constant DBusSignatureIter; subiter : access DBusSignatureIter)  -- dbus-signature.h:72
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_signature_iter_recurse";

   function dbus_signature_validate (signature : Interfaces.C.Strings.chars_ptr; error : access dbus_errors_h.DBusError) return dbus_types_h.dbus_bool_t  -- dbus-signature.h:76
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_signature_validate";

   function dbus_signature_validate_single (signature : Interfaces.C.Strings.chars_ptr; error : access dbus_errors_h.DBusError) return dbus_types_h.dbus_bool_t  -- dbus-signature.h:80
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_signature_validate_single";

   function dbus_type_is_valid (typecode : int) return dbus_types_h.dbus_bool_t  -- dbus-signature.h:84
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_type_is_valid";

   function dbus_type_is_basic (typecode : int) return dbus_types_h.dbus_bool_t  -- dbus-signature.h:87
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_type_is_basic";

   function dbus_type_is_container (typecode : int) return dbus_types_h.dbus_bool_t  -- dbus-signature.h:89
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_type_is_container";

   function dbus_type_is_fixed (typecode : int) return dbus_types_h.dbus_bool_t  -- dbus-signature.h:91
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_type_is_fixed";

end dbus_signature_h;

pragma Style_Checks (On);
pragma Warnings (On, "-gnatwu");
