pragma Ada_2012;

pragma Style_Checks (Off);
pragma Warnings (Off, "-gnatwu");

with Interfaces.C; use Interfaces.C;
with dbus_types_h;

package dbus_threads_h is

   type DBusMutex is null record;   -- incomplete struct

   type DBusCondVar is null record;   -- incomplete struct

   type DBusMutexNewFunction is access function return access DBusMutex
   with Convention => C;  -- dbus-threads.h:48

   type DBusMutexFreeFunction is access procedure (arg1 : access DBusMutex)
   with Convention => C;  -- dbus-threads.h:50

   type DBusMutexLockFunction is access function (arg1 : access DBusMutex) return dbus_types_h.dbus_bool_t
   with Convention => C;  -- dbus-threads.h:52

   type DBusMutexUnlockFunction is access function (arg1 : access DBusMutex) return dbus_types_h.dbus_bool_t
   with Convention => C;  -- dbus-threads.h:54

   type DBusRecursiveMutexNewFunction is access function return access DBusMutex
   with Convention => C;  -- dbus-threads.h:63

   type DBusRecursiveMutexFreeFunction is access procedure (arg1 : access DBusMutex)
   with Convention => C;  -- dbus-threads.h:66

   type DBusRecursiveMutexLockFunction is access procedure (arg1 : access DBusMutex)
   with Convention => C;  -- dbus-threads.h:70

   type DBusRecursiveMutexUnlockFunction is access procedure (arg1 : access DBusMutex)
   with Convention => C;  -- dbus-threads.h:74

   type DBusCondVarNewFunction is access function return access DBusCondVar
   with Convention => C;  -- dbus-threads.h:79

   type DBusCondVarFreeFunction is access procedure (arg1 : access DBusCondVar)
   with Convention => C;  -- dbus-threads.h:82

   type DBusCondVarWaitFunction is access procedure (arg1 : access DBusCondVar; arg2 : access DBusMutex)
   with Convention => C;  -- dbus-threads.h:94

   type DBusCondVarWaitTimeoutFunction is access function
        (arg1 : access DBusCondVar;
         arg2 : access DBusMutex;
         arg3 : int) return dbus_types_h.dbus_bool_t
   with Convention => C;  -- dbus-threads.h:103

   type DBusCondVarWakeOneFunction is access procedure (arg1 : access DBusCondVar)
   with Convention => C;  -- dbus-threads.h:110

   type DBusCondVarWakeAllFunction is access procedure (arg1 : access DBusCondVar)
   with Convention => C;  -- dbus-threads.h:116

   subtype DBusThreadFunctionsMask is unsigned;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_MUTEX_NEW_MASK : constant DBusThreadFunctionsMask := 1;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_MUTEX_FREE_MASK : constant DBusThreadFunctionsMask := 2;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_MUTEX_LOCK_MASK : constant DBusThreadFunctionsMask := 4;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_MUTEX_UNLOCK_MASK : constant DBusThreadFunctionsMask := 8;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_CONDVAR_NEW_MASK : constant DBusThreadFunctionsMask := 16;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_CONDVAR_FREE_MASK : constant DBusThreadFunctionsMask := 32;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_CONDVAR_WAIT_MASK : constant DBusThreadFunctionsMask := 64;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_CONDVAR_WAIT_TIMEOUT_MASK : constant DBusThreadFunctionsMask := 128;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_CONDVAR_WAKE_ONE_MASK : constant DBusThreadFunctionsMask := 256;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_CONDVAR_WAKE_ALL_MASK : constant DBusThreadFunctionsMask := 512;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_RECURSIVE_MUTEX_NEW_MASK : constant DBusThreadFunctionsMask := 1024;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_RECURSIVE_MUTEX_FREE_MASK : constant DBusThreadFunctionsMask := 2048;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_RECURSIVE_MUTEX_LOCK_MASK : constant DBusThreadFunctionsMask := 4096;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_RECURSIVE_MUTEX_UNLOCK_MASK : constant DBusThreadFunctionsMask := 8192;
   DBusThreadFunctionsMask_DBUS_THREAD_FUNCTIONS_ALL_MASK : constant DBusThreadFunctionsMask := 16383;  -- dbus-threads.h:140

   type DBusThreadFunctions is record
      mask : aliased unsigned;  -- dbus-threads.h:156
      mutex_new : DBusMutexNewFunction;  -- dbus-threads.h:158
      mutex_free : DBusMutexFreeFunction;  -- dbus-threads.h:159
      mutex_lock : DBusMutexLockFunction;  -- dbus-threads.h:160
      mutex_unlock : DBusMutexUnlockFunction;  -- dbus-threads.h:161
      condvar_new : DBusCondVarNewFunction;  -- dbus-threads.h:163
      condvar_free : DBusCondVarFreeFunction;  -- dbus-threads.h:164
      condvar_wait : DBusCondVarWaitFunction;  -- dbus-threads.h:165
      condvar_wait_timeout : DBusCondVarWaitTimeoutFunction;  -- dbus-threads.h:166
      condvar_wake_one : DBusCondVarWakeOneFunction;  -- dbus-threads.h:167
      condvar_wake_all : DBusCondVarWakeAllFunction;  -- dbus-threads.h:168
      recursive_mutex_new : DBusRecursiveMutexNewFunction;  -- dbus-threads.h:170
      recursive_mutex_free : DBusRecursiveMutexFreeFunction;  -- dbus-threads.h:171
      recursive_mutex_lock : DBusRecursiveMutexLockFunction;  -- dbus-threads.h:172
      recursive_mutex_unlock : DBusRecursiveMutexUnlockFunction;  -- dbus-threads.h:173
      padding1 : access procedure;  -- dbus-threads.h:175
      padding2 : access procedure;  -- dbus-threads.h:176
      padding3 : access procedure;  -- dbus-threads.h:177
      padding4 : access procedure;  -- dbus-threads.h:178
   end record
   with Convention => C_Pass_By_Copy;  -- dbus-threads.h:180

   function dbus_threads_init (functions : access constant DBusThreadFunctions) return dbus_types_h.dbus_bool_t  -- dbus-threads.h:183
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_threads_init";

   function dbus_threads_init_default return dbus_types_h.dbus_bool_t  -- dbus-threads.h:185
   with Import => True, 
        Convention => C, 
        External_Name => "dbus_threads_init_default";

end dbus_threads_h;

pragma Style_Checks (On);
pragma Warnings (On, "-gnatwu");
