pragma Ada_2012;

pragma Style_Checks (Off);
pragma Warnings (Off, "-gnatwu");

with Interfaces.C; use Interfaces.C;
with dbus_arch_deps_h;
with Interfaces.C.Strings;

package dbus_types_h is

   subtype dbus_unichar_t is dbus_arch_deps_h.dbus_uint32_t;  -- dbus-types.h:35

   subtype dbus_bool_t is dbus_arch_deps_h.dbus_uint32_t;  -- dbus-types.h:37

   type DBus8ByteStruct is record
      first32 : aliased dbus_arch_deps_h.dbus_uint32_t;  -- dbus-types.h:146
      second32 : aliased dbus_arch_deps_h.dbus_uint32_t;  -- dbus-types.h:147
   end record
   with Convention => C_Pass_By_Copy;  -- dbus-types.h:148

   type anon_array1051 is array (0 .. 7) of aliased unsigned_char;
   type DBusBasicValue (discr : unsigned := 0) is record
      case discr is
         when 0 =>
            bytes : aliased anon_array1051;  -- dbus-types.h:162
         when 1 =>
            i16 : aliased dbus_arch_deps_h.dbus_int16_t;  -- dbus-types.h:163
         when 2 =>
            u16 : aliased dbus_arch_deps_h.dbus_uint16_t;  -- dbus-types.h:164
         when 3 =>
            i32 : aliased dbus_arch_deps_h.dbus_int32_t;  -- dbus-types.h:165
         when 4 =>
            u32 : aliased dbus_arch_deps_h.dbus_uint32_t;  -- dbus-types.h:166
         when 5 =>
            bool_val : aliased dbus_bool_t;  -- dbus-types.h:167
         when 6 =>
            i64 : aliased dbus_arch_deps_h.dbus_int64_t;  -- dbus-types.h:168
         when 7 =>
            u64 : aliased dbus_arch_deps_h.dbus_uint64_t;  -- dbus-types.h:169
         when 8 =>
            eight : aliased DBus8ByteStruct;  -- dbus-types.h:170
         when 9 =>
            dbl : aliased double;  -- dbus-types.h:171
         when 10 =>
            byt : aliased unsigned_char;  -- dbus-types.h:172
         when 11 =>
            str : Interfaces.C.Strings.chars_ptr;  -- dbus-types.h:173
         when others =>
            fd : aliased int;  -- dbus-types.h:174
      end case;
   end record
   with Convention => C_Pass_By_Copy,
        Unchecked_Union => True;  -- dbus-types.h:175

end dbus_types_h;

pragma Style_Checks (On);
pragma Warnings (On, "-gnatwu");
